/*
This is about editing an exercice (add, modify, remove an exercice) in the database.
*/

/*launch the dialog box to edit exercice exofilenamewithoutext*/
function exoEditionEditDialog(exofilenamewithoutext)
{

	$("#keywords").val(exofilenamewithoutext);
	$("#latexcode").val(exoGetLaTEXCode(exofilenamewithoutext));
	exoEditionEditDialogInit("Modifier l'exercice d'Exobank", 
		function(keywords, latexcode) {exoModify(exofilenamewithoutext, keywords, latexcode);});
	$(function() {
		$( "#dialog-editexo" ).dialog( "open");
	});
}//alert("modifier " + keywords " avec le code " + latexcode);



/*launch the dialog box to add a new exo*/
function exoEditionNewExoDialog()
{

	$("#keywords").val(keywordsList().replace(/ /g, "_"));
	$("#latexcode").val("\\begin{exercice}[titre de l'exercice]\n\n\\begin{question}\n\n\\end{question}\n\n\\begin{question}\n\n\\end{question}\n\n\n\\end{exercice}" +
	"\n\n\n\n" + 
"\\begin{correction}\n\n\\begin{question}\n\n\\end{question}\n\n\\begin{question}\n\n\\end{question}\n\n\n\\end{correction}");
		exoEditionEditDialogInit("Ajouter un exercice à la banque d'exercices", 
		function(keywords, latexcode){exoAdd(keywords, latexcode);});
		
	$(function() {
		$( "#dialog-editexo" ).dialog( "open");
	});
}//alert("ajout de " + keywords " avec le code " + latexcode);



/*initialization of the module exo_edition
- prepare the dialog box of "modification of exo" and "add an exo" (they share the same html code)
- prepare the context menu of exercices in the palette (does not work yet)*/
function exoEditionInit()
{
	exoEditionEditDialogInit("Modifier l'exercice d'Exobank",
		function(keywords, latexcode){});
	$(document).ready(function() {	
		 $('.ExoPalette').contextMenu('menuExoPalette', {

      bindings: {

        'modify': function(t) {

          alert('Trigger was '+t.id+'\nAction was Open');

        },

        'delete': function(t) {

          alert('Trigger was '+t.id+'\nAction was Delete');

        }

      }

    });
	});
	// $(document).ready( function() {
	   // $(".ExoPalette").contextMenu({menu: 'menuExoPalette'},
		  // function(action, el, pos) {
			 // alert('Action: ' + action);
	   // });
//});
}


/*this is the init function for preparing the dialog box
it initializes the dialog box with:
- title, the title of the dialog box
- performfunction is a function of the form 
	function(keywords, latexcode)
	{
	   ...
	}
	
	that takes the keywords written in the dialog box and latexcode written in the dialog box and perform an action (add, or modify...)

*/
function exoEditionEditDialogInit(title, performfunction)
{
	

	$(function() {
		// a workaround for a flaw in the demo system (http://dev.jqueryui.com/ticket/4375), ignore!
		$( "#dialog:ui-dialog" ).dialog( "destroy" );
		
		var keywords = $( "#keywords" ),
			latexcode = $( "#latexcode" ),
			password = $( "#password" ),
			allFields = $( [] ).add( keywords ).add( latexcode ),
			tips = $( ".validateTips" );

		function updateTips( t ) {
			tips
				.text( t )
				.addClass( "ui-state-highlight" );
			setTimeout(function() {
				tips.removeClass( "ui-state-highlight", 1500 );
			}, 500 );
		}

		function checkKeywords()
		{
			if(!checkEnoughLong(keywords, 10) )
			{
				keywords.addClass( "ui-state-error" );
				updateTips( "Il faut des mots-clés, sinon on arrivera pas à retrouver votre exercice. Tapez quelque chose comme 'algo_pile_appel_fractale'");
				return false;
			}
			else
			{
				return true;
			}
		}
		
		
		function checkLaTEXCode()
		{
			if(!checkEnoughLong(latexcode, 10) )
			{
				latexcode.addClass( "ui-state-error" );
				updateTips( "Le code LaTEX doit comporter plus de 10 caractères. Là, votre exercice est très petit !");
				return false;
			}
			if(!latexcode.val().startsWith("\\begin{exercice}"))
			{
				latexcode.addClass( "ui-state-error" );
				updateTips( "Il faut que le code LaTEX commence par '\\begin{exercice}'. Lisez l'aide en cliquant sur le bouton à droite.");
				return false;
			}
			if(!testLaTEXCode(latexcode.val()))
			{
				latexcode.addClass( "ui-state-error" );
				updateTips( "Le code LaTEX n'est pas conforme. Le serveur n'arrive pas à interpréter le code LaTEX. Vous trouvez ici l'erreur donné par pdflatex : <a href='tmp/tmp.log' target='_blank'>message d'erreurs</a>");
				return false;
			}
			else
			{
				return true;
			}
		}
		
		function checkEnoughLong(o, min)
		{
			return (o.val().length >= min );
		}


		
		$( "#dialog-editexo" ).dialog({
			autoOpen: false,
			height: 600,
			width: 800,
			title: title,
			modal: true,
			buttons: {
				"OK": function() {
					var bValid = true;
					allFields.removeClass( "ui-state-error" );

					bValid = bValid && checkKeywords();
					bValid = bValid && checkLaTEXCode();
					
					if ( bValid ) {
						performfunction(keywords.val(), latexcode.val());
						$( this ).dialog( "close" );
					}
				},
				"Annuler": function() {
					$( this ).dialog( "close" );
				}
			},
			close: function() {
				allFields.val( "" ).removeClass( "ui-state-error" );
			}
		});


	});
}







/*
input: exofilenamewithoutext (name of the exercice without directory information and without extension)
output: the latex code corresponding to the exo typically of the form "\begin{exercice}.... \end{exercice}\begin{correction}...\begin{correction}" 
*/
function exoGetLaTEXCode(exofilenamewithoutext) {
  // strUrl is whatever URL you need to call
  var latexcode = "";
  jQuery.ajax({
    url: 'getexo_latexcode.php',
	data: {exo: exofilenamewithoutext},
    success: function(x) {
      latexcode = x;
    },
    async:false,
	error : function(resultat, statut, erreur){
			alert(erreur);
       }
  });

  return latexcode;
}


/*this function tests if the latexcode (this is the code of the exo alone) is correct. It asks the server to compile!*/
function testLaTEXCode(latexcode) {
  var success = false;
  
  jQuery.ajax({
    type: "POST",
    url: 'exo_latexcode_test.php',
	data: {latexcode: latexcode},
    success: function(x) {
       success = (x == '');
	   if(!success)
		alert("ERREUR LATEX : \n\n" + x);
    },
    async:false,
	error : function(resultat, statut, erreur){
			alert(erreur);
			success = false;
       }
  });

  return success;
}


/*
perform a modification of an exercice in the database
*/
function exoModify(oldkeywords, newkeywords, latexcode)
{
	//alert("[FONCTIONNALITE PAS ENCORE DISPONIBLE]\n\n modifier : " + oldkeyworlds + "\n\n" + "nouveaux keywords : " + newkeywords + "\n\nlatexcode :  " + latexcode);

	$.ajax({        
	  type: "POST",
	  async: false,
	  url: "exo_modify.php",
	  data: { oldkeywords : oldkeywords, newkeywords : newkeywords, latexcode : latexcode},

	  success : function(response, statut){ // code_html contient le HTML renvoyé
			if(response == "")
			{
			    alert("Exercice modifié. Désolé la page va se rafraîchir...");
			    window.location.reload();
			}
			else
			{
			  alert("Problème : " + response);
		        }
	  },
	  
	  error : function(resultat, statut, erreur){
			alert("il y a une erreur : "  + resultat + statut + erreur);
	}
      
    }); 

    

}

/*
add an exo in the database
*/
function exoAdd(keywords, latexcode)
{
//	alert("[FONCTIONNALITE PAS ENCORE DISPONIBLE]\n\n ajouter : " + keywords + "\n\nlatexcode :  " + latexcode);

	$.ajax({        
	  type: "POST",
	  async: false,
	  url: "exo_add.php",
	  data: { keywords : keywords, latexcode : latexcode},

	  success : function(response, statut){
		      if(response == "")
			{
			    alert("Exercice ajouté. Désolé la page va se rafraîchir...");
			    window.location.reload();
			}
			else
			{
			  alert("Problème : " + response);
		        }
	            },
	  
	  error : function(resultat, statut, erreur){
			alert("il y a une erreur : "  + resultat + statut + erreur);
	}
      
    }); 







}