<?php
/*
input: request (a string representing fragments of keywords)
output: the html content of the left part of the search in the palette corresponding to the input
*/

include 'liblatexcode.php';


/*check if $haystack ends with $needle*/
function endsWith($haystack, $needle)
{
    $length = strlen($needle);
    if ($length == 0) {
        return true;
    }

    return (substr($haystack, -$length) === $needle);
}


/*return a string that the filename $filename without the extension*/
function extensionDelete($filename)
{
  $trouve_moi = ".";
  
  // cherche la postion du '.'  
  $position = strpos($filename, $trouve_moi);
  
  // enleve l'extention, tout ce qui se trouve apres le '.' 
  return substr($filename, 0, $position);
}


/*
input: string
	an array of keywords
	
output: true iff all the keyword in keywords are substr of the string string */
function matchKeywords($string, $keywords)
{
	foreach($keywords as $keyword)
	{
		if(!strstr($string, $keyword))
			return false;
	}
	
	return true;
}


/*this function returns tru iff $var is a non empty string*/
function stringNonEmpty($var)
{
    return($var != "");
}

	
/*
input: the request, ex: "   pile         file "
output: the list of keywords ["pile", "file"]
*/
function extractKeyWords($request)
{
	$var = explode(" ", trim($request));
	return array_filter($var, "stringNonEmpty");
}





/*
input:
- $dirname, the directory where are the exercices (typically './exercices/')
- $exofilenamewithoutext : the filename without extension and without directory information (eg. "algo_pile")
REQUIRES the file $dirname . $exofilenamewithoutext . ".tex" exists

ECHO what is written in the palette concerning this exercice
*/
function echoContentExo($dirname, $exofilenamewithoutext)
{
		$previewfile = $dirname . $exofilenamewithoutext . '.png';
		
		
		echo '<div class="ExoPalette" ondblclick="exoEditionEditDialog(\'' . $exofilenamewithoutext .
					'\');" src="' . $exofilenamewithoutext . '">';

		if(file_exists($previewfile))
		{
			echo '<img src="' . $previewfile . '"/>';
		}
		else
		{
			echo nl2br(fileread($dirname.$exofilenamewithoutext.".tex"));
		}
		echo '</div>';
		
		//echo '<a href="'.$dirname.$file.'">'.'[.tex]'.'</a>'.'<br />';
		
		echo '<br>';
}


/*
input: a filename (without any directoy information but with the extension)
output: yes iff it is a LaTEX file (not a directory and finishes with .tex)*/
function isLaTEXFile($file)
{
	return $file != '.' 
	   && $file != '..' 
	   && endsWith($file, '.tex') 
	   && !is_dir($dirname.$file);
}


/************************
  THE SCRIPT
  ***********************/

$dirname = './exercices/';
$request = $_GET["request"];
$keywords = extractKeyWords($request);

$dir = opendir($dirname);//we open the directory containing the exercices
$foundsth = false;

while($file = readdir($dir)) {
	if(isLaTEXFile($file) && matchKeywords($file, $keywords))
	{
		echoContentExo($dirname, extensionDelete($file));
		$foundsth = true;
	}
}

if(!$foundsth)
{
	echo 'Aucun exercice qui correspond à la requête';
}

closedir($dir); 


?>
