/*
extends String class with startsWith and endsWith methods
*/

String.prototype.startsWith = function(prefix) {
    return this.indexOf(prefix) === 0;
}

String.prototype.endsWith = function(suffix) {
    return this.match(suffix+"$") == suffix;
};

/*
input: a text input element txtField
SELECT the text in the txtField if it is of the form "<....>"
*/
function selectIfBracket(txtField)
{
	var text = txtField.value;
	
	if(text.startsWith('<') && text.endsWith('>'))
	{
		txtField.select();
	}
	
}


/*
launched when the update begin, SHOW a loading image
*/
function updateBegin(keywords)
{
	
	document.getElementById("result").innerHTML = "<img src='loading.gif' />";
	
	$.ajax({
       url : 'exo_search.php', // La ressource cible
	   type : 'GET', // Le type de la requte HTTP.
	   data : 'request=' + keywords,
	   dataType : 'html', // Le type de donnes  recevoir, ici, du HTML.
	   success : function(code_html, statut){ // code_html contient le HTML renvoy
			updateFinish(code_html);
           
       },
	   
	   error : function(resultat, statut, erreur){
			alert(erreur);
       }
    });
}

/*
when the update finishs, show the html code corresponding to the request
*/
function updateFinish(code_html)
{
	document.getElementById("result").innerHTML = code_html;
	paletteExoSetUp();
}


/*
make that a press on ENTER starts a search
*/
function cmdSearchMakeDefaultButton()
{
	$(document).ready(function() {

	   $("input").bind("keydown", function(event) {
	      // track enter key
	      var keycode = (event.keyCode ? event.keyCode : (event.which ? event.which : event.charCode));
	      if (keycode == 13) { // keycode for enter key
		 // force the 'Enter Key' to implicitly click the Update button
		 document.getElementById("cmdSearch").click();
		 return false;
	      } else  {
		 return true;
	      }
	   }); // end of function

	}); // end of document ready
}



